; Name:    NexOS Kernel - Foobar, prints only some messages
; Version: 0.1.3 (08/11/2000)
; Author:  Torben Schulz (torben@fasthack.de)
; Website: http://caffeine.tsx.org
;
; This program is distributed in the hope that it will be useful, but WITHOUT ANY
; WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
; PARTICULAR PURPOSE. The author is not responsible for any damages caused by
; this program. You use it completely on your own risk.
;
; This program is free software; you can redistribute it and/or modify it under
; the terms of the GNU General Public License as published by the Free Software
; Foundation; either version 2 of the License, or (at your option) any later
; version. See the GNU General Public License for more details. You should have
; received a copy of the GNU General Public License along with this program; if
; not, look at the website http://www.gnu.org/copyleft/gpl.html or write to the
; Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
; MA 02111-1307, USA.

[BITS 32]

jmp kernel

; ### data and functions ###

kernel_msg db "Caffeine NexOS Kernel 0.1.3 ",224," (gerstel)",0x00
intr_msg   db "Initializing interrupt functions..............",0x00
done_msg   db "done.",0x00

print:                                           ; print a message
  start:
    mov    byte dl,[ds:ebx]
    mov    byte [es:eax],dl
    inc    ebx
    add    eax,2
    test   dl,0xFF
  jnz start
ret

; ### initialize for pmode ###

kernel:
  mov    ax,0x0010                               ; load segment registers
  mov    ds,ax
  mov    ax,0x0018
  mov    es,ax

  mov    eax,0x000002DC                          ; print message
  mov    ebx,done_msg
  call   print  
  mov    eax,0x000003C0                          ; print message
  mov    ebx,kernel_msg
  call   print
    
; ### initialize interrupts ###

  mov    eax,0x00000500                          ; print message
  mov    ebx,intr_msg
  call   print
  
; !!! missing code !!!  
    
  mov    eax,0x0000055C                          ; print message
  mov    ebx,done_msg
  call   print

endless:
  jmp endless                                    ; that's it for now 